# -*- encoding: binary -*-
require "digest/md5"
class MogileFS::Chunker
  CRLF = "\r\n"
  attr_reader :io

  def initialize(io, md5)
    @io = io
    @md5 = md5 ? Digest::MD5.new : nil
  end

  def write(buf)
    rv = buf.bytesize
    @io.write("#{rv.to_s(16)}\r\n")
    @io.write(buf)
    @md5.update(buf) if @md5
    @io.write(CRLF)
    rv
  end

  def flush
    if @md5
      content_md5 = [ @md5.digest ].pack('m').strip
      warn "Content-MD5: #{content_md5}\r\n" if $DEBUG
      @io.write("0\r\nContent-MD5: #{content_md5}\r\n\r\n")
    else
      @io.write("0\r\n\r\n")
    end
  end
end
